diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/imalloc.h tarsnap-autoconf-1.0.34/libcperciva/util/imalloc.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/imalloc.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/imalloc.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,33 @@
+#ifndef _IMALLOC_H_
+#define _IMALLOC_H_
+
+#include <errno.h>
+#include <stdint.h>
+#include <stdlib.h>
+
+/**
+ * imalloc(nrec, reclen):
+ * Allocate ${nrec} records of length ${reclen}.  Check for size_t overflow.
+ */
+static inline void *
+imalloc(size_t nrec, size_t reclen)
+{
+
+	if (nrec > SIZE_MAX / reclen) {
+		errno = ENOMEM;
+		return (NULL);
+	} else {
+		return (malloc(nrec * reclen));
+	}
+}
+
+/**
+ * IMALLOC(p, nrec, type):
+ * Allocate ${nrec} records of type ${type} and store the pointer in ${p}.
+ * Return non-zero on failure.
+ */
+#define IMALLOC(p, nrec, type)						\
+	((((p) = (type *)imalloc((nrec), sizeof(type))) == NULL) &&	\
+	    ((nrec) > 0))
+
+#endif /* !_IMALLOC_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/monoclock.c tarsnap-autoconf-1.0.34/libcperciva/util/monoclock.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/monoclock.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/monoclock.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,41 @@
+#include <sys/time.h>
+
+#include <time.h>
+
+#include "warnp.h"
+
+#include "monoclock.h"
+
+/**
+ * monoclock_get(tv):
+ * Store the current time in ${tv}.  If CLOCK_MONOTONIC is available, use
+ * that clock; otherwise, use gettimeofday(2).
+ */
+int
+monoclock_get(struct timeval * tv)
+{
+#ifdef CLOCK_MONOTONIC
+	struct timespec tp;
+#endif
+
+#ifdef CLOCK_MONOTONIC
+	if (clock_gettime(CLOCK_MONOTONIC, &tp)) {
+		warnp("clock_gettime(CLOCK_MONOTONIC)");
+		goto err0;
+	}
+	tv->tv_sec = tp.tv_sec;
+	tv->tv_usec = tp.tv_nsec / 1000;
+#else
+	if (gettimeofday(tv, NULL)) {
+		warnp("gettimeofday");
+		goto err0;
+	}
+#endif
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/monoclock.h tarsnap-autoconf-1.0.34/libcperciva/util/monoclock.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/monoclock.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/monoclock.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,13 @@
+#ifndef _MONOCLOCK_H_
+#define _MONOCLOCK_H_
+
+#include <sys/time.h>
+
+/**
+ * monoclock_get(tv):
+ * Store the current time in ${tv}.  If CLOCK_MONOTONIC is available, use
+ * that clock; otherwise, use gettimeofday(2).
+ */
+int monoclock_get(struct timeval *);
+
+#endif /* !_MONOCLOCK_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/readpass.c tarsnap-autoconf-1.0.34/libcperciva/util/readpass.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/readpass.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/readpass.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,181 @@
+#include <signal.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <termios.h>
+#include <unistd.h>
+
+#include "warnp.h"
+
+#include "readpass.h"
+
+#define MAXPASSLEN 2048
+
+/* Signals we need to block. */
+int badsigs[] = {
+	SIGALRM, SIGHUP, SIGINT,
+	SIGPIPE, SIGQUIT, SIGTERM,
+	SIGTSTP, SIGTTIN, SIGTTOU
+};
+#define NSIGS sizeof(badsigs)/sizeof(badsigs[0])
+
+/* Has a signal of this type been received? */
+static volatile sig_atomic_t gotsig[NSIGS];
+
+/* Signal handler. */
+static void
+handle(int sig)
+{
+	size_t i;
+
+	for (i = 0; i < NSIGS; i++) {
+		if (sig == badsigs[i])
+			gotsig[i] = 1;
+	}
+}
+
+/**
+ * readpass(passwd, prompt, confirmprompt, devtty)
+ * If ${devtty} is non-zero, read a password from /dev/tty if possible; if
+ * not, read from stdin.  If reading from a tty (either /dev/tty or stdin),
+ * disable echo and prompt the user by printing ${prompt} to stderr.  If
+ * ${confirmprompt} is non-NULL, read a second password (prompting if a
+ * terminal is being used) and repeat until the user enters the same password
+ * twice.  Return the password as a malloced NUL-terminated string via
+ * ${passwd}.
+ */
+int
+readpass(char ** passwd, const char * prompt,
+    const char * confirmprompt, int devtty)
+{
+	FILE * readfrom;
+	char passbuf[MAXPASSLEN];
+	char confpassbuf[MAXPASSLEN];
+	struct sigaction sa, savedsa[NSIGS];
+	struct termios term, term_old;
+	size_t i;
+	int usingtty;
+
+	/*
+	 * If devtty != 0, try to open /dev/tty; if that fails, or if devtty
+	 * is zero, we'll read the password from stdin instead.
+	 */
+	if ((devtty == 0) || ((readfrom = fopen("/dev/tty", "r")) == NULL))
+		readfrom = stdin;
+
+	/* We have not received any signals yet. */
+	for (i = 0; i < NSIGS; i++)
+		gotsig[i] = 0;
+
+	/*
+	 * If we receive a signal while we're reading the password, we might
+	 * end up with echo disabled; to prevent this, we catch the signals
+	 * here, and we'll re-send them to ourselves later after we re-enable
+	 * terminal echo.
+	 */
+	sa.sa_handler = handle;
+	sa.sa_flags = 0;
+	sigemptyset(&sa.sa_mask);
+	for (i = 0; i < NSIGS; i++)
+		sigaction(badsigs[i], &sa, &savedsa[i]);
+
+	/* If we're reading from a terminal, try to disable echo. */
+	if ((usingtty = isatty(fileno(readfrom))) != 0) {
+		if (tcgetattr(fileno(readfrom), &term_old)) {
+			warnp("Cannot read terminal settings");
+			goto err2;
+		}
+		memcpy(&term, &term_old, sizeof(struct termios));
+		term.c_lflag = (term.c_lflag & ~ECHO) | ECHONL;
+		if (tcsetattr(fileno(readfrom), TCSANOW, &term)) {
+			warnp("Cannot set terminal settings");
+			goto err2;
+		}
+	}
+
+retry:
+	/* If we have a terminal, prompt the user to enter the password. */
+	if (usingtty)
+		fprintf(stderr, "%s: ", prompt);
+
+	/* Read the password. */
+	if (fgets(passbuf, MAXPASSLEN, readfrom) == NULL) {
+		warnp("Cannot read password");
+		goto err3;
+	}
+
+	/* Confirm the password if necessary. */
+	if (confirmprompt != NULL) {
+		if (usingtty)
+			fprintf(stderr, "%s: ", confirmprompt);
+		if (fgets(confpassbuf, MAXPASSLEN, readfrom) == NULL) {
+			warnp("Cannot read password");
+			goto err3;
+		}
+		if (strcmp(passbuf, confpassbuf)) {
+			fprintf(stderr,
+			    "Passwords mismatch, please try again\n");
+			goto retry;
+		}
+	}
+
+	/* Terminate the string at the first "\r" or "\n" (if any). */
+	passbuf[strcspn(passbuf, "\r\n")] = '\0';
+
+	/* If we changed terminal settings, reset them. */
+	if (usingtty)
+		tcsetattr(fileno(readfrom), TCSANOW, &term_old);
+
+	/* Restore old signals. */
+	for (i = 0; i < NSIGS; i++)
+		sigaction(badsigs[i], &savedsa[i], NULL);
+
+	/* If we intercepted a signal, re-issue it. */
+	for (i = 0; i < NSIGS; i++) {
+		if (gotsig[i])
+			raise(badsigs[i]);
+	}
+
+	/* Close /dev/tty if we opened it. */
+	if (readfrom != stdin)
+		fclose(readfrom);
+
+	/* Copy the password out. */
+	if ((*passwd = strdup(passbuf)) == NULL) {
+		warnp("Cannot allocate memory");
+		goto err1;
+	}
+
+	/*
+	 * Zero any stored passwords.  This is not guaranteed to work, since a
+	 * "sufficiently intelligent" compiler can optimize these out due to
+	 * the values not being accessed again; some people try to avoid this
+	 * problem by zeroing buffers via a volatile-casted pointed, but this
+	 * is not sufficient -- it guarantees that *a* buffer is zeroed but
+	 * not that it is the only buffer containing the data in question.
+	 * Unfortunately the C standard does not provide any way to mark data
+	 * as "sensitive" in order to prevent extra copies being sprinkled
+	 * around the implementation address space.
+	 */
+	memset(passbuf, 0, MAXPASSLEN);
+	memset(confpassbuf, 0, MAXPASSLEN);
+
+	/* Success! */
+	return (0);
+
+err3:
+	/* Reset terminal settings if necessary. */
+	if (usingtty)
+		tcsetattr(fileno(readfrom), TCSAFLUSH, &term_old);
+err2:
+	/* Close /dev/tty if we opened it. */
+	if (readfrom != stdin)
+		fclose(readfrom);
+err1:
+	/* Zero any stored passwords. */
+	memset(passbuf, 0, MAXPASSLEN);
+	memset(confpassbuf, 0, MAXPASSLEN);
+
+	/* Failure! */
+	return (-1);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/readpass.h tarsnap-autoconf-1.0.34/libcperciva/util/readpass.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/readpass.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/readpass.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,22 @@
+#ifndef _READPASS_H_
+#define _READPASS_H_
+
+/* Avoid namespace collisions with other "readpass" functions. */
+#ifdef readpass
+#undef readpass
+#endif
+#define readpass libcperciva_readpass
+
+/**
+ * readpass(passwd, prompt, confirmprompt, devtty)
+ * If ${devtty} is non-zero, read a password from /dev/tty if possible; if
+ * not, read from stdin.  If reading from a tty (either /dev/tty or stdin),
+ * disable echo and prompt the user by printing ${prompt} to stderr.  If
+ * ${confirmprompt} is non-NULL, read a second password (prompting if a
+ * terminal is being used) and repeat until the user enters the same password
+ * twice.  Return the password as a malloced NUL-terminated string via
+ * ${passwd}.
+ */
+int readpass(char **, const char *, const char *, int);
+
+#endif /* !_READPASS_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/sock.c tarsnap-autoconf-1.0.34/libcperciva/util/sock.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/sock.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/sock.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,477 @@
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <sys/un.h>
+
+#include <netinet/in.h>
+
+#include <arpa/inet.h>
+
+#include <errno.h>
+#include <fcntl.h>
+#include <netdb.h>
+#include <stdint.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "imalloc.h"
+#include "warnp.h"
+
+#include "sock.h"
+#include "sock_internal.h"
+
+/* Convert a path into a socket address. */
+static struct sock_addr **
+sock_resolve_unix(const char * addr)
+{
+	struct sock_addr ** sas;
+	struct sock_addr * sa;
+	struct sockaddr_un * sa_un;
+
+	/* Allocate and populate a sockaddr_un structure. */
+	if ((sa_un = malloc(sizeof(struct sockaddr_un))) == NULL)
+		goto err0;
+	memset(sa_un, 0, sizeof(struct sockaddr_un));
+	sa_un->sun_family = AF_UNIX;
+	if (strlen(addr) >= sizeof(sa_un->sun_path)) {
+		warn0("socket path too long: %s", addr);
+		goto err1;
+	}
+	strcpy(sa_un->sun_path, addr);
+
+	/* Allocate and populate our wrapper. */
+	if ((sa = malloc(sizeof(struct sock_addr))) == NULL)
+		goto err1;
+	sa->ai_family = AF_UNIX;
+	sa->ai_socktype = SOCK_STREAM;
+	sa->name = (struct sockaddr *)sa_un;
+	sa->namelen = sizeof(struct sockaddr_un);
+
+	/* Allocate and populate an array of pointers. */
+	if ((sas = malloc(2 * sizeof(struct sock_addr *))) == NULL)
+		goto err2;
+	sas[0] = sa;
+	sas[1] = NULL;
+
+	/* Success! */
+	return (sas);
+
+err2:
+	free(sa);
+err1:
+	free(sa_un);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/* Resolve a host into a list of socket addresses. */
+static struct sock_addr **
+sock_resolve_host(const char * addr, const char * ports)
+{
+	struct addrinfo hints;
+	struct addrinfo * res;
+	struct addrinfo * r;
+	struct sock_addr ** sas;
+	size_t n;
+	int error;
+
+	/* Create hints structure. */
+	memset(&hints, 0, sizeof(hints));
+	hints.ai_family = AF_UNSPEC;
+	hints.ai_socktype = SOCK_STREAM;
+	hints.ai_protocol = IPPROTO_TCP;
+
+	/* Perform DNS lookup. */
+	if ((error = getaddrinfo(addr, ports, &hints, &res)) != 0) {
+		warn0("Error looking up %s: %s", addr, gai_strerror(error));
+		goto err0;
+	}
+
+	/* Count addresses returned. */
+	for (n = 0, r = res; r != NULL; r = r->ai_next)
+		n++;
+
+	/* Allocate our response array. */
+	if (IMALLOC(sas, n + 1, struct sock_addr *))
+		goto err1;
+
+	/* Create address structures. */
+	for (n = 0, r = res; r != NULL; n++, r = r->ai_next) {
+		/* Allocate a structure. */
+		if ((sas[n] = malloc(sizeof(struct sock_addr))) == NULL)
+			goto err2;
+
+		/* Copy in the address metadata. */
+		sas[n]->ai_family = r->ai_family;
+		sas[n]->ai_socktype = r->ai_socktype;
+		sas[n]->namelen = r->ai_addrlen;
+
+		/* Duplicate the address. */
+		if ((sas[n]->name = malloc(sas[n]->namelen)) == NULL)
+			goto err3;
+		memcpy(sas[n]->name, r->ai_addr, sas[n]->namelen);
+	}
+
+	/* Terminate array with a NULL. */
+	sas[n] = NULL;
+
+	/* Free the linked list of addresses returned by getaddrinfo. */
+	freeaddrinfo(res);
+
+	/* Success! */
+	return (sas);
+
+err3:
+	free(sas[n]);
+err2:
+	for (; n > 0; n--) {
+		free(sas[n - 1]->name);
+		free(sas[n - 1]);
+	}
+	free(sas);
+err1:
+	freeaddrinfo(res);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/* Parse an IPv6 address into a socket address. */
+static struct sock_addr **
+sock_resolve_ipv6(const char * addr, in_port_t p)
+{
+	struct sock_addr ** sas;
+	struct sock_addr * sa;
+	struct sockaddr_in6 * sin6;
+
+	/* Allocate and populate a sockaddr_in6 structure. */
+	if ((sin6 = malloc(sizeof(struct sockaddr_in6))) == NULL)
+		goto err0;
+	memset(sin6, 0, sizeof(struct sockaddr_in6));
+	sin6->sin6_family = AF_INET6;
+	sin6->sin6_port = htons(p);
+	if (inet_pton(AF_INET6, addr, &sin6->sin6_addr) != 1) {
+		warn0("Error parsing IP address: %s", addr);
+		goto err1;
+	}
+
+	/* Allocate and populate our wrapper. */
+	if ((sa = malloc(sizeof(struct sock_addr))) == NULL)
+		goto err1;
+	sa->ai_family = AF_INET6;
+	sa->ai_socktype = SOCK_STREAM;
+	sa->name = (struct sockaddr *)sin6;
+	sa->namelen = sizeof(struct sockaddr_in6);
+
+	/* Allocate and populate an array of pointers. */
+	if ((sas = malloc(2 * sizeof(struct sock_addr *))) == NULL)
+		goto err2;
+	sas[0] = sa;
+	sas[1] = NULL;
+
+	/* Success! */
+	return (sas);
+
+err2:
+	free(sa);
+err1:
+	free(sin6);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/* Parse an IPv4 address into a socket address. */
+static struct sock_addr **
+sock_resolve_ipv4(const char * addr, in_port_t p)
+{
+	struct sock_addr ** sas;
+	struct sock_addr * sa;
+	struct sockaddr_in * sin;
+
+	/* Allocate and populate a sockaddr_in structure. */
+	if ((sin = malloc(sizeof(struct sockaddr_in))) == NULL)
+		goto err0;
+	memset(sin, 0, sizeof(struct sockaddr_in));
+	sin->sin_family = AF_INET;
+	sin->sin_port = htons(p);
+	if (inet_pton(AF_INET, addr, &sin->sin_addr) != 1) {
+		warn0("Error parsing IP address: %s", addr);
+		goto err1;
+	}
+
+	/* Allocate and populate our wrapper. */
+	if ((sa = malloc(sizeof(struct sock_addr))) == NULL)
+		goto err1;
+	sa->ai_family = AF_INET;
+	sa->ai_socktype = SOCK_STREAM;
+	sa->name = (struct sockaddr *)sin;
+	sa->namelen = sizeof(struct sockaddr_in);
+
+	/* Allocate and populate an array of pointers. */
+	if ((sas = malloc(2 * sizeof(struct sock_addr *))) == NULL)
+		goto err2;
+	sas[0] = sa;
+	sas[1] = NULL;
+
+	/* Success! */
+	return (sas);
+
+err2:
+	free(sa);
+err1:
+	free(sin);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * sock_resolve(addr):
+ * Return a NULL-terminated array of pointers to sock_addr structures.
+ */
+struct sock_addr **
+sock_resolve(const char * addr)
+{
+	struct sock_addr ** res;
+	char * s;
+	char * ports;
+	char * ips;
+	long p;
+
+	/* If the address starts with '/', it's a unix socket. */
+	if (addr[0] == '/') {
+		res = sock_resolve_unix(addr);
+		goto done;
+	}
+
+	/* Copy the address so that we can mangle it. */
+	if ((s = strdup(addr)) == NULL)
+		goto err0;
+
+	/* The address should end with :port.  Look for the last ':'. */
+	if ((ports = strrchr(s, ':')) == NULL) {
+		warn0("Address must contain port number: %s", s);
+		goto err1;
+	}
+	*ports++ = '\0';
+
+	/* If the address doesn't start with '[', it's a host name. */
+	if (s[0] != '[') {
+		res = sock_resolve_host(s, ports);
+		goto done1;
+	}
+
+	/* The address (sans :port) should end with ']'. */
+	if (s[strlen(s) - 1] != ']') {
+		warn0("Invalid [IP address]: %s", s);
+		goto err1;
+	}
+
+	/* Extract the IP address string. */
+	ips = &s[1];
+	ips[strlen(ips) - 1] = '\0';
+
+	/*
+	 * Parse the port number.  If strtol fails to parse the port number,
+	 * it will return 0; but that's fine since port 0 is invalid anyway.
+	 */
+	p = strtol(ports, NULL, 10);
+	if ((p <= 0) || (p >= 65536)) {
+		warn0("Invalid port number: %s", ports);
+		goto err1;
+	}
+
+	/* If the IP address contains ':', it's IPv6; otherwise, IPv4. */
+	if (strrchr(ips, ':') != NULL)
+		res = sock_resolve_ipv6(ips, p);
+	else
+		res = sock_resolve_ipv4(ips, p);
+
+done1:
+	/* Free string allocated by strdup. */
+	free(s);
+done:
+	/* Return result from sock_resolve_foo. */
+	return (res);
+
+err1:
+	free(s);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * sock_listener(sa):
+ * Create a socket, set SO_REUSEADDR, bind it to the socket address ${sa},
+ * mark it for listening, and mark it as non-blocking.
+ */
+int
+sock_listener(const struct sock_addr * sa)
+{
+	int s;
+	int val = 1;
+
+	/* Create a socket. */
+	if ((s = socket(sa->ai_family, sa->ai_socktype, 0)) == -1) {
+		warnp("socket(%d, %d)", sa->ai_family, sa->ai_socktype);
+		goto err0;
+	}
+
+	/* Set SO_REUSEADDR. */
+	if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &val, sizeof(val))) {
+		warnp("setsockopt(SO_REUSEADDR)");
+		goto err1;
+	}
+
+	/* Bind the socket. */
+	if (bind(s, sa->name, sa->namelen)) {
+		warnp("error binding socket");
+		goto err1;
+	}
+
+	/* Mark the socket as listening. */
+	if (listen(s, 10)) {
+		warnp("error marking socket as listening");
+		goto err1;
+	}
+
+	/* Make the socket as non-blocking. */
+	if (fcntl(s, F_SETFL, O_NONBLOCK) == -1) {
+		warnp("error marking socket as non-blocking");
+		goto err1;
+	}
+
+	/* Success! */
+	return (s);
+
+err1:
+	close(s);
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * sock_connect(sas):
+ * Iterate through the addresses in ${sas}, attempting to create a socket and
+ * connect (blockingly).  Once connected, stop iterating, mark the socket as
+ * non-blocking, and return it.
+ */
+int
+sock_connect(struct sock_addr * const * sas)
+{
+	int s = -1;
+
+	/* Iterate through the addresses provided. */
+	for (; sas[0] != NULL; sas++) {
+		/* Create a socket. */
+		if ((s = socket(sas[0]->ai_family,
+		    sas[0]->ai_socktype, 0)) == -1)
+			continue;
+
+		/* Attempt to connect. */
+		if (connect(s, sas[0]->name, sas[0]->namelen) == 0)
+			break;
+
+		/* Close the socket; this address didn't work. */
+		close(s);
+	}
+
+	/* Did we manage to connect? */
+	if (sas[0] == NULL) {
+		warn0("Could not connect");
+		goto err0;
+	}
+
+	/* Mark the socket as non-blocking. */
+	if (fcntl(s, F_SETFL, O_NONBLOCK) == -1) {
+		warnp("Cannot make connection non-blocking");
+		goto err1;
+	}
+
+	/* Success! */
+	return (s);
+
+err1:
+	close(s);
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * sock_connect_nb(sa):
+ * Create a socket, mark it as non-blocking, and attempt to connect to the
+ * address ${sa}.  Return the socket (connected or in the process of
+ * connecting) or -1 on error.
+ */
+int
+sock_connect_nb(const struct sock_addr * sa)
+{
+	int s;
+
+	/* Create a socket. */
+	if ((s = socket(sa->ai_family, sa->ai_socktype, 0)) == -1)
+		goto err0;
+
+	/* Mark the socket as non-blocking. */
+	if (fcntl(s, F_SETFL, O_NONBLOCK) == -1) {
+		warnp("Cannot make socket non-blocking");
+		goto err1;
+	}
+
+	/* Attempt to connect. */
+	if ((connect(s, sa->name, sa->namelen) == -1) &&
+	    (errno != EINPROGRESS) &&
+	    (errno == EINTR))
+		goto err1;
+
+	/* We have a connect(ed|ing) socket. */
+	return (s);
+
+err1:
+	close(s);
+err0:
+	/* We failed to connect to this address. */
+	return (-1);
+}
+
+/**
+ * sock_addr_free(sa):
+ * Free the provided sock_addr structure.
+ */
+void
+sock_addr_free(struct sock_addr * sa)
+{
+
+	/* Compatibility with free(NULL). */
+	if (sa == NULL)
+		return;
+
+	/* Free the protocol-specific address structure and our struct. */
+	free(sa->name);
+	free(sa);
+}
+
+/**
+ * sock_addr_freelist(sas):
+ * Free the provided NULL-terminated array of sock_addr structures.
+ */
+void
+sock_addr_freelist(struct sock_addr ** sas)
+{
+	struct sock_addr ** p;
+
+	/* Compatibility with free(NULL). */
+	if (sas == NULL)
+		return;
+
+	/* Free structures until we hit NULL. */
+	for (p = sas; *p != NULL; p++)
+		sock_addr_free(*p);
+
+	/* Free the list. */
+	free(sas);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/sock.h tarsnap-autoconf-1.0.34/libcperciva/util/sock.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/sock.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/sock.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,56 @@
+#ifndef _SOCK_H_
+#define _SOCK_H_
+
+/**
+ * Address strings are of the following forms:
+ * /path/to/unix/socket
+ * [ip.v4.ad.dr]:port
+ * [ipv6:add::ress]:port
+ * host.name:port
+ */
+
+/* Opaque address structure. */
+struct sock_addr;
+
+/**
+ * sock_resolve(addr):
+ * Return a NULL-terminated array of pointers to sock_addr structures.
+ */
+struct sock_addr ** sock_resolve(const char *);
+
+/**
+ * sock_listener(sa):
+ * Create a socket, set SO_REUSEADDR, bind it to the socket address ${sa},
+ * mark it for listening, and mark it as non-blocking.
+ */
+int sock_listener(const struct sock_addr *);
+
+/**
+ * sock_connect(sas):
+ * Iterate through the addresses in ${sas}, attempting to create a socket and
+ * connect (blockingly).  Once connected, stop iterating, mark the socket as
+ * non-blocking, and return it.
+ */
+int sock_connect(struct sock_addr * const *);
+
+/**
+ * sock_connect_nb(sa):
+ * Create a socket, mark it as non-blocking, and attempt to connect to the
+ * address ${sa}.  Return the socket (connected or in the process of
+ * connecting) or -1 on error.
+ */
+int sock_connect_nb(const struct sock_addr *);
+
+/**
+ * sock_addr_free(sa):
+ * Free the provided sock_addr structure.
+ */
+void sock_addr_free(struct sock_addr *);
+
+/**
+ * sock_addr_freelist(sas):
+ * Free the provided NULL-terminated array of sock_addr structures.
+ */
+void sock_addr_freelist(struct sock_addr **);
+
+#endif /* !_SOCK_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/sock_internal.h tarsnap-autoconf-1.0.34/libcperciva/util/sock_internal.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/sock_internal.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/sock_internal.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,14 @@
+#ifndef _SOCK_INTERNAL_H_
+#define _SOCK_INTERNAL_H_
+
+#include <sys/socket.h>
+
+/* Socket address structure. */
+struct sock_addr {
+	int ai_family;
+	int ai_socktype;
+	struct sockaddr * name;
+	socklen_t namelen;
+};
+
+#endif /* !_SOCK_INTERNAL_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/sock_util.c tarsnap-autoconf-1.0.34/libcperciva/util/sock_util.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/sock_util.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/sock_util.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,258 @@
+#include <sys/socket.h>
+#include <sys/un.h>
+
+#include <netinet/in.h>
+
+#include <arpa/inet.h>
+
+#include <stdlib.h>
+#include <string.h>
+
+#include "asprintf.h"
+#include "sock.h"
+
+#include "sock_util.h"
+#include "sock_internal.h"
+
+/**
+ * sock_addr_cmp(sa1, sa2):
+ * Return non-zero iff the socket addresses ${sa1} and ${sa2} are different.
+ */
+int
+sock_addr_cmp(const struct sock_addr * sa1, const struct sock_addr * sa2)
+{
+
+	/* Family, socket type, and name length must match. */
+	if ((sa1->ai_family != sa2->ai_family) ||
+	    (sa1->ai_socktype != sa2->ai_socktype) ||
+	    (sa1->namelen != sa2->namelen))
+		return (1);
+
+	/* The required length of the sockaddr must match. */
+	if (memcmp(sa1->name, sa2->name, sa1->namelen) != 0)
+		return (1);
+
+	/* Everything matched. */
+	return (0);
+}
+
+/**
+ * sock_addr_dup(sa):
+ * Duplicate the provided socket address.
+ */
+struct sock_addr *
+sock_addr_dup(const struct sock_addr * sa)
+{
+	struct sock_addr * sa2;
+
+	/* Allocate a struct sock_addr and copy fields. */
+	if ((sa2 = malloc(sizeof(struct sock_addr))) == NULL)
+		goto err0;
+	sa2->ai_family = sa->ai_family;
+	sa2->ai_socktype = sa->ai_socktype;
+	sa2->namelen = sa->namelen;
+
+	/* Allocate and copy the sockaddr. */
+	if ((sa2->name = malloc(sa2->namelen)) == NULL)
+		goto err1;
+	memcpy(sa2->name, sa->name, sa2->namelen);
+
+	/* Success! */
+	return (sa2);
+
+err1:
+	free(sa2);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * sock_addr_duplist(sas):
+ * Duplicate the provided list of socket addresses.
+ */
+struct sock_addr **
+sock_addr_duplist(struct sock_addr * const * sas)
+{
+	struct sock_addr ** sas2;
+	size_t i;
+
+	/* Count socket addresses. */
+	for (i = 0; sas[i] != NULL; i++)
+		continue;
+
+	/* Allocate the list to hold addresses plus a NULL terminator. */
+	if ((sas2 = malloc((i + 1) * sizeof(struct sock_addr *))) == NULL)
+		goto err0;
+
+	/* Fill the list with NULLs to make error-path cleanup simpler. */
+	for (i = 0; sas[i] != NULL; i++)
+		sas2[i] = NULL;
+	sas2[i] = NULL;
+
+	/* Duplicate addresses. */
+	for (i = 0; sas[i] != NULL; i++) {
+		if ((sas2[i] = sock_addr_dup(sas[i])) == NULL)
+			goto err1;
+	}
+
+	/* Success! */
+	return (sas2);
+
+err1:
+	/*
+	 * Regardless of how many addresses we managed to duplicate before
+	 * failing and being sent here, we have a valid socket address list,
+	 * so we can free it and its constituent addresses easily.
+	 */
+	sock_addr_freelist(sas2);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * sock_addr_serialize(sa, buf, buflen):
+ * Allocate a buffer and serialize the socket address ${sa} into it.  Return
+ * the buffer via ${buf} and its length via ${buflen}.  The serialization is
+ * machine and operating system dependent.
+ */
+int
+sock_addr_serialize(const struct sock_addr * sa,
+    uint8_t ** buf, size_t * buflen)
+{
+	uint8_t * p;
+
+	/* Compute buffer length and allocate buffer. */
+	*buflen = 2 * sizeof(int) + sizeof(socklen_t) + sa->namelen;
+	if ((p = *buf = malloc(*buflen)) == NULL)
+		goto err0;
+
+	/* Copy in data. */
+	memcpy(p, &sa->ai_family, sizeof(int));
+	p += sizeof(int);
+	memcpy(p, &sa->ai_socktype, sizeof(int));
+	p += sizeof(int);
+	memcpy(p, &sa->namelen, sizeof(socklen_t));
+	p += sizeof(socklen_t);
+	memcpy(p, sa->name, sa->namelen);
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * sock_addr_deserialize(buf, buflen):
+ * Deserialize the ${buflen}-byte serialized socket address from ${buf}.
+ */
+struct sock_addr *
+sock_addr_deserialize(const uint8_t * buf, size_t buflen)
+{
+	struct sock_addr * sa;
+
+	/* Sanity check. */
+	if (buflen < 2 * sizeof(int) + sizeof(socklen_t))
+		goto err0;
+
+	/* Allocate a structure and copy in fields. */
+	if ((sa = malloc(sizeof(struct sock_addr))) == NULL)
+		goto err0;
+	memcpy(&sa->ai_family, buf, sizeof(int));
+	buf += sizeof(int);
+	memcpy(&sa->ai_socktype, buf, sizeof(int));
+	buf += sizeof(int);
+	memcpy(&sa->namelen, buf, sizeof(socklen_t));
+	buf += sizeof(socklen_t);
+
+	/* Allocate and copy the sockaddr. */
+	if (buflen != 2 * sizeof(int) + sizeof(socklen_t) + sa->namelen)
+		goto err1;
+	if ((sa->name = malloc(sa->namelen)) == NULL)
+		goto err1;
+	memcpy(sa->name, buf, sa->namelen);
+
+	/* Success! */
+	return (sa);
+
+err1:
+	free(sa);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/* Prettyprint an IPv4 address. */
+static char *
+prettyprint_ipv4(struct sockaddr_in * name)
+{
+	char addr[INET_ADDRSTRLEN];
+	char * s;
+
+	/* Convert IP address to string. */
+	if (inet_ntop(AF_INET, &name->sin_addr, addr, sizeof(addr)) == NULL)
+		return (NULL);
+
+	/* Construct address string. */
+	if (asprintf(&s, "[%s]:%d", addr, ntohs(name->sin_port)) == -1)
+		return (NULL);
+
+	/* Success! */
+	return (s);
+}
+
+/* Prettyprint an IPv6 address. */
+static char *
+prettyprint_ipv6(struct sockaddr_in6 * name)
+{
+	char addr[INET6_ADDRSTRLEN];
+	char * s;
+
+	/* Convert IPv6 address to string. */
+	if (inet_ntop(AF_INET6, &name->sin6_addr, addr, sizeof(addr)) == NULL)
+		return (NULL);
+
+	/* Construct address string. */
+	if (asprintf(&s, "[%s]:%d", addr, ntohs(name->sin6_port)) == -1)
+		return (NULL);
+
+	/* Success! */
+	return (s);
+}
+
+/* Prettyprint a UNIX address. */
+static char *
+prettyprint_unix(struct sockaddr_un * name)
+{
+
+	/* Just strdup the path. */
+	return (strdup(name->sun_path));
+}
+
+/**
+ * sock_addr_prettyprint(sa):
+ * Allocate and return a string in one of the forms
+ * /path/to/unix/socket
+ * [ip.v4.ad.dr]:port
+ * [ipv6:add::ress]:port
+ * representing the provided socket address.
+ */
+char *
+sock_addr_prettyprint(const struct sock_addr * sa)
+{
+
+	/* Handle different types of addresses differently. */
+	switch (sa->ai_family) {
+	case AF_INET:
+		return (prettyprint_ipv4((struct sockaddr_in *)(sa->name)));
+	case AF_INET6:
+		return (prettyprint_ipv6((struct sockaddr_in6 *)(sa->name)));
+	case AF_UNIX:
+		return (prettyprint_unix((struct sockaddr_un *)(sa->name)));
+	default:
+		return (strdup("Unknown address"));
+	}
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/sock_util.h tarsnap-autoconf-1.0.34/libcperciva/util/sock_util.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/sock_util.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/sock_util.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,51 @@
+#ifndef _SOCK_UTIL_H_
+#define _SOCK_UTIL_H_
+
+#include <stdint.h>
+
+/* Opaque address structure. */
+struct sock_addr;
+
+/**
+ * sock_addr_cmp(sa1, sa2):
+ * Return non-zero iff the socket addresses ${sa1} and ${sa2} are different.
+ */
+int sock_addr_cmp(const struct sock_addr *, const struct sock_addr *);
+
+/**
+ * sock_addr_dup(sa):
+ * Duplicate the provided socket address.
+ */
+struct sock_addr * sock_addr_dup(const struct sock_addr *);
+
+/**
+ * sock_addr_duplist(sas):
+ * Duplicate the provided list of socket addresses.
+ */
+struct sock_addr ** sock_addr_duplist(struct sock_addr * const *);
+
+/**
+ * sock_addr_serialize(sa, buf, buflen):
+ * Allocate a buffer and serialize the socket address ${sa} into it.  Return
+ * the buffer via ${buf} and its length via ${buflen}.  The serialization is
+ * machine and operating system dependent.
+ */
+int sock_addr_serialize(const struct sock_addr *, uint8_t **, size_t *);
+
+/**
+ * sock_addr_deserialize(buf, buflen):
+ * Deserialize the ${buflen}-byte serialized socket address from ${buf}.
+ */
+struct sock_addr * sock_addr_deserialize(const uint8_t *, size_t);
+
+/**
+ * sock_addr_prettyprint(sa):
+ * Allocate and return a string in one of the forms
+ * /path/to/unix/socket
+ * [ip.v4.ad.dr]:port
+ * [ipv6:add::ress]:port
+ * representing the provided socket address.
+ */
+char * sock_addr_prettyprint(const struct sock_addr *);
+
+#endif /* !_SOCK_H_ */
